package 
{
	import adobe.utils.CustomActions;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.globalization.NumberParseResult;
	
	
	public class TheWorld extends Sprite
	{
		//ball and wave
		private var oneWave:OneWave;
		private var bg:BG;
		
		private const nBall:int = 60;
		private var deltaX:Number;
		private var ballArray:Array;
		private var yArray:Array;
		
		
		//physics
		private var amplitude:Number = 200;
		private var lambda:Number = 400;
		private var period:Number = 120;
		private var tt:Number = 0;
		
		private var startX:Number = 0;
		
		
		//control
		private var isPlay:Boolean = false;
		private var isStep:Boolean = false;
		private var allControl:AllControl;
		
		
		public function TheWorld():void
		{
			//once
			bg = new BG();
			this.addChild(bg);
			
			oneWave = new OneWave();
			oneWave.x = 40;
			oneWave.y = 320;
			this.addChild(oneWave);
			
			//ball
			deltaX = 950 / (nBall - 1);
			ballArray = new Array();
			yArray = new Array();
			for (var i:int = 0; i < nBall; i++) {
				var ballMC:BallMC = new BallMC();
				ballMC.x = i * deltaX;
				ballMC.y = 0;
				oneWave.addChild(ballMC);
				
				ballArray.push(ballMC);
				yArray.push(0);
			}
			
			
			//control
			allControl = new AllControl();
			this.addChild(allControl);
			
			allControl.btnPlayStop.addEventListener(MouseEvent.CLICK, clickPlayStop);
			allControl.btnStep.addEventListener(MouseEvent.CLICK, clickStep);
			allControl.btnReset.addEventListener(MouseEvent.CLICK, clickReset);
			
			
			this.addEventListener(Event.ENTER_FRAME, myshow);
		}
		
		
		private function myshow(e:Event):void {
		
			
			startX = tt * (lambda / period);
			
			
			//算 yArray
			for (var i:int = 0; i < nBall; i++) {
				var xx:Number = i * deltaX;
				yArray[i] = (xx>startX?0:amplitude * Math.sin(2 * Math.PI * xx / lambda - 2 * Math.PI * tt / period));
				
				ballArray[i].y = yArray[i];
			}
			
			
			if(isPlay){
				tt++;
				
				if (isStep) {
					isPlay = false;
				}
			}
		}
		
		
		private function clickPlayStop(e:MouseEvent):void {
			isPlay = !isPlay;
			
			isStep = false;
		}
		
		private function clickStep(e:MouseEvent):void {
			isStep = true;
			isPlay = true;
		}
		
		private function clickReset(e:MouseEvent):void {
			tt = 0;
			
			isPlay = false;
			isStep = false;
		}
	}

}